/**
 * This file is part of the SIASAR package.
 *
 * Next.js version 11.1.4
 *
 * SIASAR Global is a joint initiative launched by the governments of Honduras,
 * Nicaragua and Panama that soon expanded to other regions. The strategic
 * purpose of this initiative is to have a basic, updated and comparable
 * information tool on the rural water supply and sanitation services in place
 * in a given country.
 *
 * @summary SIASAR_3 Front-end
 *
 * @author   Pedro Pelaez <pedro@front.id>
 *
 * @license GPL-3.0
 *
 * @see     http://globalsiasar.org/es/contact
 */
// DynForm
///////////////////////
@import "../01_base/mixins";

$dynformImageSize: 120px;

.dynform-filters-wrapper {
  padding-top: 30px;

  @include tablet {
    display: flex;
    align-items: flex-end;
  }

  @include desktop {
    padding-top: 0;
  }

  .filter-item {
    margin-bottom: 15px;

    @include tablet {
      margin-right: 15px;
      margin-bottom: 0;
    }

    &.filter-item-select {
      label {
        display: block;
      }
    }

    &.filter-item-checkbox {
      label {
        white-space: nowrap;
      }
    }

    &:last-child {
      margin-right: 0;
      margin-bottom: 0;
    }

    select {
      min-width: 85px;
    }
  }

  + form {
    margin-top: 30px;
  }
}


.dynform {

  &.form-surveys-filter {
    .form-actions {
      display: flex;
      flex-wrap: wrap;
      gap: 0.5rem;

      > * {
        display: block;
        margin-left: 0;
        margin-right: 0;

        &.btn-secondary {
          padding: 5px 8px 4px;

          @include tablet {
            padding: 7px 15px 6px;
          }

          svg.fa-circle-plus {
            display: none;

            @include tablet {
              display: var(--fa-display, inline-block);
            }
          }
        }
      }
    }
  }

  &.form-user-edit > .accordion > fieldset.group {
    margin: 0;
  }

  // Structural indent.
  .accordion .accordion__panel {
    padding: 20px 5px 0;

    @include desktop {
      padding: 15px 10px 0;
    }

    .field-block-wrapper {

      > * {

        &.dynform-field {
          padding-left: 10px;
          padding-right: 10px;
          margin-bottom: 30px;
        }

        &.dynform-multivalued-field {
          margin-bottom: 30px;
        }

        > .field-label,
        > .field-label .title,
        > legend {
          font-size: 18px;
          font-weight: 500;
        }
      }

      > fieldset {

        &.dynform-multivalued-field {
          margin-left: 4px;
          margin-right: 4px;
        }

        &.group {

          > legend {
            width: calc(100% + 20px);
            margin-left: -10px;
          }

          > fieldset.group {
            border-left: none;
            padding-left: 11px;
            margin-left: 5px;
            margin-bottom: 30px;
          }
        }
      }
    }
  }

  div.dynform-add {
    margin-top: 15px;
  }

  .error-required,
  .error-not-valid {
    input, textarea, select {
      &:not(.not-validate) {
        border: 1px solid $color-red-08;
      }
    }
  }

  .field-fake {
    background-color: $color-red-03;
    padding: 3px;

    .fake-id {
      color: $color-red-01;
      font-size: medium;
    }

    .fake-type {
      color: $color-red-01;
      font-size: medium;
    }
  }

  .dynform-multivalued {
    list-style-type: none;

    .dynform-item {
      clear: both;

      &:after {
        float: none;
      }

      .dynform-remove,
      .dynform-field {
        float: left;
      }
    }
  }

  .dynform-multivalued-field {
    display: block;

    .dynform-item {
      display: flex;
      flex-direction: row-reverse;
      justify-content: left;
      align-items: center;
      gap: 0.5rem;
      margin-bottom: 15px;

      .form-field-boolean.field-amount-single .field-input {
        display: flex;
      }
    }
  }

  .field-description {
    width: 100%;
    color: $color-grey-10;
    font-size: 14px;
    margin: 5px 0;
  }

  .dynform-field {

    &.form-field-volume {

      .field-input {
        gap: 0.5rem;

        > * {
          margin-bottom: 10px;

          @include tablet {
            margin-bottom: 0;
          }

          &:last-child {
            margin-bottom: 0;
          }
        }
      }
    }

    .field-description {

      p {
        margin: 0 0 10px;

        &:last-of-type {
          margin: 0;
        }
      }
    }

    .error {
      color: $color-red-01;
    }

    .ok {
      color: $color-green-01;
    }
  }

  .field-label {
    margin-bottom: 10px;

    .title {
      font-size: 18px;
      font-weight: 500;
    }
  }

  &.filters-wrapper-form {

    > .group {

      @include tablet {
        display: flex;
        gap: 0.8rem;
      }

      > * {
        display: block;
        margin-bottom: 15px;

        @include tablet {
          flex-shrink: 1;
          flex-grow: 1;
          margin: 0;
        }

        &:last-child {
          margin-bottom: 0;
        }
      }

      .field-label {
        display: block;
        font-size: 16px;
        font-weight: 500;
        margin-bottom: 2px;
      }

      .field-input {
        margin: 0;
      }
    }

    .form-actions {
      margin-top: 25px;
    }
  }

  &:not(.filters-wrapper-form) fieldset {
    border-color: $transparency-black-02;
    padding: 0 6px 15px;
    margin-left: 0;
    margin-right: 0;

    &.dynform-multivalued-field {
      padding: 0 6px 15px;
      margin-left: 0;
      margin-right: 0;

      > legend {
        font-size: 18px;
        font-weight: 500;
        border: none;
        padding: 0 7px 0 2px;
        margin-left: -4px;
      }

      &.field-type-radio_inquiring_status,
      &.field-type-radio_pointing_status {
        padding: 15px 0;

        > legend {
          font-size: 18px;
          font-weight: 500;
          border: none;
          padding: 0 10px;
          margin: 0 0 5px;
        }

        .form-field-select {
          padding: 0 10px;
        }
      }

      .dynform fieldset,
      fieldset {
        @extend %clearfix;
        background: $transparency-black-02;
        border: none;
        padding: 15px 10px;
        margin: 0 0 30px;

        + fieldset {
          background: $transparency-black-02;

          > legend {
            float: left;
          }
        }
      }

      .form-multivalued-list {

        table {

          td > form {
            border-left: 1px solid $transparency-black-05;
            border-bottom: 1px solid $transparency-black-05;
            padding-bottom: 15px;
            padding-left: 10px;
            margin-left: 5px;
            margin-bottom: 15px;

            .form-actions {
              margin-bottom: 0;
            }
          }
        }
      }

      + fieldset.dynform-multivalued-field {
        margin-top: 15px;
      }
    }

    &.group {
      @extend %clearfix;
      overflow: hidden;
      background: $transparency-black-02;
      border: none;
      padding: 15px 10px;
      margin: 0 0 30px;

      .field-group-description {
        color: $color-grey-10;
        font-size: 14px;
        margin-top: -10px;
        margin-bottom: 20px;
      }

      > * {
        &:not(legend) {
          margin-bottom: 10px;

          &:not(.field-group-description) {
            border-left: 1px solid $color-grey-01;
            padding-left: 10px;
            margin-left: 5px;
          }

          &.group {
            border-left: none;
          }
        }

        &:last-child {
          margin-bottom: 0;
        }
      }

      > legend {
        width: calc(100% + 20px);
        font-size: 16px;
        font-weight: 500;
        border-bottom: 1px solid $color-grey-09;
        float: left;
        padding: 0 10px 10px;
        margin-left: -10px;
        margin-bottom: 20px;

        &:before {
          content: none;
        }

        span {
          background: transparent;
        }

        + * {
          clear: both;
        }
      }

      .group {
        margin-bottom: 20px;
      }

      .field-label {
        font-size: 16px;
        font-weight: 500;
      }

      + .form-actions {
        margin-top: -20px;
        margin-bottom: 30px;
      }
    }

    > legend {
      padding: 0 7px 0 2px;
    }
  }

  legend,
  label {

    .required {
      color: $color-red-08;
      margin-right: 5px;
      font-weight: bold;
    }

    .catalog-id {
      font-size: large;
      font-weight: bold;
      padding: 0 10px 0 0;
    }
  }

  .level1,
  .level2,
  .level3,
  .levelsdg {
    .catalog-id:before {
      display: inline-block;
      margin-right: 5px;
      content: " ";
      min-width: 15px;
      min-height: 15px;
      border-radius: 100px;
    }
  }

  .level1 {
    .catalog-id:before {
      background-color: $color-blue-03;
    }
  }

  .level2 {
    .catalog-id:before {
      background-color: $color-green-03;
    }
  }

  .level3 {
    .catalog-id:before {
      background-color: $color-green-04;
    }
  }

  .levelsdg {
    .catalog-id:before {
      background-color: $color-purple-01;
    }
  }

  .composed-field {
    display: flex;

    .composed-field-block {
      flex-flow: column;

      & label {
        width: fit-content;
      }
    }
  }

  .form-field-image_reference {

    .dynform-multivalued {
      display: flex;
      flex-wrap: wrap;
      margin: 0;

      .dynform-item {
        position: relative;
        flex: 0 0 auto;
        align-items: flex-start;
        margin: 1rem;

        img {
          height: $dynformImageSize;
          width: auto;
          box-shadow: 0 4px 1rem -4px $color-black-01;
        }

        .image-buttons {
          display: flex;
          flex-direction: column;
          gap: 0.25rem;

          .dynform-remove {
            position: absolute;
            top: 0.5rem;
            right: 0.5rem;
            background: $color-white-01;
            border-radius: 50%;
            box-shadow: 0 4px 1rem -4px $color-black-01;

            &:hover {
              transform: translateY(-3px);
            }
          }
        }

        .image-preview {
          position: relative;

          .dynform-filesize {
            position: absolute;
            top: 0.5rem;
            left: 0.5rem;
            padding: 1px 2px;
            background: $color-white-01;
            border-radius: 2px;
            box-shadow: 0 4px 1rem -4px $color-black-01;
          }
        }
      }
    }
  }
}

.modal-diameter {
  ul {
    list-style-type: none;
  }
}


.dynform-multivalued-field {
  margin-bottom: 30px;

  &:last-of-type(div) {
    margin-bottom: 0;
  }
}

// Inline items
.dynform-field {

  .pill-style .pill-content {
    min-height: auto;
    margin: 0;
  }

  .field-input {

    @include tablet {
      display: flex;
      align-items: center;
      flex-direction: inherit;
      gap: 0.7rem;
    }

    .map-container {
      width: 100%;
      height: 25rem;
    }

    .options-wrapper {
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      justify-content: left;
      gap: 0.5rem;

      select {
        display: block;
      }
    }

    .parents {
      display: block;

      span {
        display: inline-block;

        &.separator {
          margin: 0 8px;
        }

        &:last-of-type {
          margin-right: 5px;
        }
      }
    }

    > .form-type-radio {
      margin-top: 5px;
      margin-left: 15px;
      margin-bottom: 0;

      .dynform-item {
        margin-bottom: 15px;

        &:last-child {
          margin-bottom: 0;
        }
      }
    }

    .composed-field {

      > * {
        margin-left: 10px;

        &:first-child {
          margin-left: 0;
        }
      }

      label {
        display: block;
      }
    }

    .password-inputs {
      display: flex;
      flex-wrap: wrap;
      width: 100%;
      gap: 0.5rem;
      align-items: center;

      > input {
        flex-grow: 1;
      }
    }

    .field-internal-rows {
      display: flex;
      flex-direction: column;
      gap: 0.5rem;
    }
  }

  // Suggestions.
  .no-suggestions {
    color: $color-grey-04;
    padding-top: 2px;
  }

  .suggestions {
    max-height: 143px;
    border: 1px solid $color-blue-02;
    border-top-width: 0;
    list-style: none;
    overflow-y: auto;
    padding: 0;
    margin-top: 0;

    li {
      cursor: pointer;
      background-color: transparent;
      transition: background-color $duration color $duration;
      padding: 5px 10px;

      &:hover {
        color: $color-white-01;
        background-color: $color-blue-01;
      }
    }
  }
}

.form-field-select,
.form-field-boolean,
.form-field-integer,
.form-field-decimal,
.form-field-length,
.form-field-ulid,
.form-field-date,
.form-field-radio_boolean,
.form-field-user_reference,
.form-field-country_reference,
.form-field-household_process_reference {

  @include tablet {
    display: flex;
    flex-wrap: wrap;
  }

  > .field-label {
    @include tablet {
      margin-right: 15px;
      margin-bottom: 0;
    }
  }

  .field-input {
    margin: 5px 0;
  }

  > .field-description {
    width: 100%;
    margin: 5px 0 0;
  }
}

.form-field-integer,
.form-field-decimal {

  @include tablet {
    align-items: center;
    flex-wrap: wrap;
  }
}

.form-field-radio_boolean,
.form-field-ulid,
.form-field-select,
.form-field-date {

  @include tablet {
    align-items: center;
  }

  .field-input {

    ul {
      display: flex;

      @include tablet {
        margin: 5px 0;
      }

      li {
        margin-left: 20px;

        &:first-child {
          margin-left: 0;
        }
      }
    }
  }
}

.form-field-boolean {

  @include tablet {
    align-items: center;
  }

  .field-input {
    display: inline-flex;
    gap: 0;

    .true-label {
      padding-top: 2px;
      margin-right: 8px;
    }

    .false-label {
      padding-top: 2px;
      margin-left: 9px;
    }
  }
}

.form-field-user_reference,
.form-field-country_reference,
.form-field-household_process_reference {

  @include desktop {
    align-items: center;
  }

  .field-input {

    span {
      display: flex;
      justify-content: center;
      align-items: center;
      gap: 0.5rem
    }
  }
}

.form-field-household_process_reference {
  .field-input {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    justify-content: center;
    gap: 0.5rem;
  }

  .btn-household-process-reference {
    @extend %btn;
    background-size: contain;
    background-repeat: no-repeat;
    background-position: left 5px center;
    padding-right: 15px;
    padding-left: 33px;

    &:hover, &:focus {
      opacity: .9;
    }
    
    &.btn-point {
      background-color: #b45e05;
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;

      &::before {
        content: '';
        width: 14px;
        height: 14px;
        border-radius: 50%;
        background-color: whitesmoke;
        position: absolute;
        left: 0.75rem;
        z-index: 2;
      }
    }

    &.btn-community {
      background-image: url(image-url('community.png'));
      background-color: #37751c;
    }
  }
}

.form-field-point_link {
  .field-input {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    justify-content: center;
    gap: 0.5rem;
  }

  .btn-household-process-reference {
    @extend %btn;
    background-size: contain;
    background-repeat: no-repeat;
    background-position: left 5px center;
    padding-right: 15px;
    padding-left: 33px;

    &:hover, &:focus {
      opacity: .9;
    }

    &.btn-point {
      background-color: #b45e05;
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;

      &::before {
        content: '';
        width: 14px;
        height: 14px;
        border-radius: 50%;
        background-color: whitesmoke;
        position: absolute;
        left: 0.75rem;
        z-index: 2;
      }
    }

    &.btn-community {
      background-image: url(image-url('community.png'));
      background-color: #37751c;
    }
  }
}

.form-field-select {
  flex-wrap: wrap;
}

.form-field-length {
  .field-input {
    input {
      width: 100%;

      @include tablet {
        width: auto;
      }

      + select {
        width: 100%;
        margin-top: 5px;

        @include tablet {
          width: auto;
          margin-top: 0;
          margin-left: 5px;
        }
      }
    }
  }
}

.accordion .accordion__panel .form-field-select,
.form-field-select {

  > ul.form-type-radio {
    margin-top: 15px;
    margin-left: 15px;
    margin-bottom: 0;

    > li {
      &:last-child {
        margin-bottom: 5px;
      }
    }
  }
}

.inquiry-form-logs {
  background: $transparency-blue-02;
  padding: 20px 10px 10px;
  margin-top: 20px;

  h2 {
    text-align: center;
    margin: 0;
  }

  table {
    width: 100%;

    tbody tr {
      color: $color-black-01;

      &.level-100 .level,
      &.level-debug .level {
        background-color: $color-blue-04;
      }

      &.level-200 .level,
      &.level-info .level {
        background-color: $color-blue-05;
      }

      &.level-250 .level,
      &.level-notice .level {
        background-color: $color-blue-06;
      }

      &.level-300 .level,
      &.level-warning .level {
        background-color: $color-orange-03;
      }

      &.level-400 .level,
      &.level-error .level {
        background-color: $color-red-04;
      }

      &.level-500 .level,
      &.level-critical .level {
        background-color: $color-red-05;
      }

      &.level-550 .level,
      &.level-alert .level {
        background-color: $color-red-06;
      }

      &.level-600 .level,
      &.level-emergency .level {
        background-color: $color-red-07;
      }

      &.level-success .level {
        background-color: $color-green-05;
      }

      td {
        border: 1px solid $color-grey-06;
        padding: 4px 8px;

        &.level {
          color: $color-white-01;
          text-transform: uppercase;
        }

        &.time,
        &.level,
        &.user {
          text-align: center;
          white-space: nowrap;
        }

        &.message {
          width: 100%;
        }
      }
    }
  }
}

.point-form-logs {
  background: $transparency-blue-02;
  padding: 20px 10px 10px;
  margin-top: 20px;

  h2 {
    text-align: center;
    margin: 0;
  }

  table {
    width: 100%;

    tbody tr {
      color: $color-black-01;

      &.level-100 .level,
      &.level-debug .level {
        background-color: $color-blue-04;
      }

      &.level-200 .level,
      &.level-info .level {
        background-color: $color-blue-05;
      }

      &.level-250 .level,
      &.level-notice .level {
        background-color: $color-blue-06;
      }

      &.level-300 .level,
      &.level-warning .level {
        background-color: $color-orange-03;
      }

      &.level-400 .level,
      &.level-error .level {
        background-color: $color-red-04;
      }

      &.level-500 .level,
      &.level-critical .level {
        background-color: $color-red-05;
      }

      &.level-550 .level,
      &.level-alert .level {
        background-color: $color-red-06;
      }

      &.level-600 .level,
      &.level-emergency .level {
        background-color: $color-red-07;
      }

      &.level-success .level {
        background-color: $color-green-05;
      }

      td {
        border: 1px solid $color-grey-06;
        padding: 4px 8px;

        &.level {
          color: $color-white-01;
          text-transform: uppercase;
        }

        &.time,
        &.level,
        &.user {
          text-align: center;
          white-space: nowrap;
        }

        &.message {
          width: 100%;
        }
      }
    }
  }
}

.form-field-translatable_language_reference {
  .field-input {
    display: inline;

    .progress-bar-container {
      display: flex;
      align-items: center;

      .progress-bar {
        height: 5px;
        background-color: $color-blue-01;
      }

      .progress-bar-negative {
        height: 5px;
        background-color: $color-grey-01;
      }

      .progress-percentage {
        padding: .5rem;
      }
    }

    .progress-bar-details {
      display: flex;
      align-items: center;
      justify-content: center;
      gap: 1rem;

      .progress-bar-detail {
        .title {
          font-weight: bold;
        }
      }
    }
  }
}

// autosave controls

.autosave-container {
  display: flex;
  flex-wrap: wrap;
  align-items: center;
  justify-content: center;
  gap: 1rem;
  padding: 1rem;
  accent-color: $color-blue-02;

  & > * {
    display: flex;
    gap: 0.75rem;
    align-items: center;
  }

  input[type="range"] {
    flex-grow: 1;
  }

  input[type="number"] {
    min-width: 0px;
    width: 50px;
  }
}

.user-with-gravatar {
  display: inline-flex;

  .username {
    display: flex;
    align-items: center;
  }
}

.form-pointHistory-edit,
.form-inquiryHistory-edit {
  .dynform-field {
    display: flex;

    .form-multivalued-list {
      ul {
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
        list-style-type: none;
        padding: 0;
        margin: 0;

        li {
          margin: 10px;
          padding: 0.5rem;
          background-color: lightgrey;
          border-radius: 8px;

          .history-administrative-division {
            .label {
              font-weight: bold;
            }
          }

          .history-creation-date {
            .label {
              font-weight: bold;
            }
          }
        }
      }
    }
  }
}